*! version 1.0.4 - 5/20/05, 2/24/00 - pbe
program define sme, eclass
  version 6.0 
  syntax varlist(max=2) [, DFE(real 0) SSE(real 0) Alpha(real .05) ]
  tokenize `varlist' 

  /*set initial values from factorial anova */
  local dfr = `dfe'
  if `dfe' == 0 { local dfr = e(df_r) }
  local sserror = `sse'
  if `sse' == 0 { local sserror = e(rss) }
  local mse = `sserror'/`dfr'  
   
  local dfm = e(df_m)   
  local depvar `e(depvar)'
  estimates hold smehold1
  local icount = 0        /* counts number of tests of simple main effects */

  quietly summarize `2'
  local i = r(min)
  local imax = r(max)
  local q = r(max) - r(min) + 1
  quietly summarize `1'
  local p = r(max) - r(min) + 1
  display " "

   while `i' <= `imax' {
   anova `depvar' `1' if `2'==`i', noanova
   local icount = `icount' + 1
   display in green "Test of " "`1'" " at " "`2'" "(" `i' "): F(" /*
   */ e(df_m) "/" `dfr' ")  = " in yellow e(mss)/e(df_m)/`mse'
   local i = `i' + 1   }
  
  /* display section */ 
  display _newline                      
  display in green "Critical value of F for alpha = " `alpha' " using ..."
  display in green _dup(50) "-"
  
  display in green "Dunn's procedure              = " /*
  */ in yellow invfprob(e(df_m), `dfr' ,(3*`alpha') / (`p' + `q'))
  
  display in green "Marascuilo & Levin            = " /*
  */ in yellow invfprob(e(df_m), `dfr' ,(2*`alpha') / (`p' + `q'))
                        
  display in green "per family error rate         = " /*
  */ in yellow invfprob(e(df_m), `dfr' ,`alpha'/`icount')
  
  display in green "simultaneous test procedure   = " /*
  */ in yellow `dfm'*invfprob(`dfm',`dfr' ,3*`alpha')/e(df_m)

  /* replace estimates */
  estimates unhold smehold1 

end



